// subsys_pcie_ext_f2sdram.v

// Generated using ACDS version 17.0 290

`timescale 1 ps / 1 ps
module subsys_pcie_ext_f2sdram (
		input  wire         clk,                  //           clock.clk
		output wire [31:0]  avm_m0_address,       // expanded_master.address
		output wire         avm_m0_read,          //                .read
		input  wire         avm_m0_waitrequest,   //                .waitrequest
		input  wire [127:0] avm_m0_readdata,      //                .readdata
		output wire         avm_m0_write,         //                .write
		output wire [127:0] avm_m0_writedata,     //                .writedata
		input  wire         avm_m0_readdatavalid, //                .readdatavalid
		output wire [15:0]  avm_m0_byteenable,    //                .byteenable
		output wire [5:0]   avm_m0_burstcount,    //                .burstcount
		input  wire         reset,                //           reset.reset
		input  wire [25:0]  avs_s0_address,       //  windowed_slave.address
		input  wire         avs_s0_read,          //                .read
		output wire [127:0] avs_s0_readdata,      //                .readdata
		input  wire         avs_s0_write,         //                .write
		input  wire [127:0] avs_s0_writedata,     //                .writedata
		output wire         avs_s0_readdatavalid, //                .readdatavalid
		output wire         avs_s0_waitrequest,   //                .waitrequest
		input  wire [15:0]  avs_s0_byteenable,    //                .byteenable
		input  wire [5:0]   avs_s0_burstcount     //                .burstcount
	);

	altera_address_span_extender #(
		.DATA_WIDTH           (128),
		.BYTEENABLE_WIDTH     (16),
		.MASTER_ADDRESS_WIDTH (32),
		.SLAVE_ADDRESS_WIDTH  (26),
		.SLAVE_ADDRESS_SHIFT  (4),
		.BURSTCOUNT_WIDTH     (6),
		.CNTL_ADDRESS_WIDTH   (1),
		.SUB_WINDOW_COUNT     (1),
		.MASTER_ADDRESS_DEF   (64'b0000000000000000000000000000000000000000000000000000000000000000)
	) ext_f2sdram (
		.clk                  (clk),                                                                  //           clock.clk
		.reset                (reset),                                                                //           reset.reset
		.avs_s0_address       (avs_s0_address),                                                       //  windowed_slave.address
		.avs_s0_read          (avs_s0_read),                                                          //                .read
		.avs_s0_readdata      (avs_s0_readdata),                                                      //                .readdata
		.avs_s0_write         (avs_s0_write),                                                         //                .write
		.avs_s0_writedata     (avs_s0_writedata),                                                     //                .writedata
		.avs_s0_readdatavalid (avs_s0_readdatavalid),                                                 //                .readdatavalid
		.avs_s0_waitrequest   (avs_s0_waitrequest),                                                   //                .waitrequest
		.avs_s0_byteenable    (avs_s0_byteenable),                                                    //                .byteenable
		.avs_s0_burstcount    (avs_s0_burstcount),                                                    //                .burstcount
		.avm_m0_address       (avm_m0_address),                                                       // expanded_master.address
		.avm_m0_read          (avm_m0_read),                                                          //                .read
		.avm_m0_waitrequest   (avm_m0_waitrequest),                                                   //                .waitrequest
		.avm_m0_readdata      (avm_m0_readdata),                                                      //                .readdata
		.avm_m0_write         (avm_m0_write),                                                         //                .write
		.avm_m0_writedata     (avm_m0_writedata),                                                     //                .writedata
		.avm_m0_readdatavalid (avm_m0_readdatavalid),                                                 //                .readdatavalid
		.avm_m0_byteenable    (avm_m0_byteenable),                                                    //                .byteenable
		.avm_m0_burstcount    (avm_m0_burstcount),                                                    //                .burstcount
		.avs_cntl_address     (1'b0),                                                                 //     (terminated)
		.avs_cntl_read        (1'b0),                                                                 //     (terminated)
		.avs_cntl_readdata    (),                                                                     //     (terminated)
		.avs_cntl_write       (1'b0),                                                                 //     (terminated)
		.avs_cntl_writedata   (64'b0000000000000000000000000000000000000000000000000000000000000000), //     (terminated)
		.avs_cntl_byteenable  (8'b00000000)                                                           //     (terminated)
	);

endmodule
