	component subsys_pcie_msi_irq is
		port (
			clk         : in  std_logic                     := 'X';             -- clk
			csr_write   : in  std_logic                     := 'X';             -- write
			csr_read    : in  std_logic                     := 'X';             -- read
			csr_addr    : in  std_logic_vector(1 downto 0)  := (others => 'X'); -- address
			csr_wrdata  : in  std_logic_vector(31 downto 0) := (others => 'X'); -- writedata
			csr_rddata  : out std_logic_vector(31 downto 0);                    -- readdata
			irq         : out std_logic;                                        -- irq
			reset_n     : in  std_logic                     := 'X';             -- reset_n
			avmm_addr   : in  std_logic_vector(4 downto 0)  := (others => 'X'); -- address
			avmm_wrdata : in  std_logic_vector(31 downto 0) := (others => 'X'); -- writedata
			avmm_rddata : out std_logic_vector(31 downto 0);                    -- readdata
			avmm_write  : in  std_logic                     := 'X';             -- write
			avmm_read   : in  std_logic                     := 'X'              -- read
		);
	end component subsys_pcie_msi_irq;

	u0 : component subsys_pcie_msi_irq
		port map (
			clk         => CONNECTED_TO_clk,         --            clock.clk
			csr_write   => CONNECTED_TO_csr_write,   --              csr.write
			csr_read    => CONNECTED_TO_csr_read,    --                 .read
			csr_addr    => CONNECTED_TO_csr_addr,    --                 .address
			csr_wrdata  => CONNECTED_TO_csr_wrdata,  --                 .writedata
			csr_rddata  => CONNECTED_TO_csr_rddata,  --                 .readdata
			irq         => CONNECTED_TO_irq,         -- interrupt_sender.irq
			reset_n     => CONNECTED_TO_reset_n,     --            reset.reset_n
			avmm_addr   => CONNECTED_TO_avmm_addr,   --     vector_slave.address
			avmm_wrdata => CONNECTED_TO_avmm_wrdata, --                 .writedata
			avmm_rddata => CONNECTED_TO_avmm_rddata, --                 .readdata
			avmm_write  => CONNECTED_TO_avmm_write,  --                 .write
			avmm_read   => CONNECTED_TO_avmm_read    --                 .read
		);

