// subsys_pcie_msi_irq.v

// Generated using ACDS version 17.0 290

`timescale 1 ps / 1 ps
module subsys_pcie_msi_irq (
		input  wire        clk,         //            clock.clk
		input  wire        csr_write,   //              csr.write
		input  wire        csr_read,    //                 .read
		input  wire [1:0]  csr_addr,    //                 .address
		input  wire [31:0] csr_wrdata,  //                 .writedata
		output wire [31:0] csr_rddata,  //                 .readdata
		output wire        irq,         // interrupt_sender.irq
		input  wire        reset_n,     //            reset.reset_n
		input  wire [4:0]  avmm_addr,   //     vector_slave.address
		input  wire [31:0] avmm_wrdata, //                 .writedata
		output wire [31:0] avmm_rddata, //                 .readdata
		input  wire        avmm_write,  //                 .write
		input  wire        avmm_read    //                 .read
	);

	altera_msi_to_gic_gen #(
		.DEVICE_FAMILY    ("Arria 10"),
		.MSG_DATA_WORD    (32),
		.ADDR_WIDTH       (5),
		.DATA_ENTRY_DEPTH (4),
		.FIFO_DEPTH       (4),
		.MEMORY_TYPE      ("RAM_BLOCK_TYPE=MLAB")
	) msi_irq (
		.clk         (clk),         //            clock.clk
		.reset_n     (reset_n),     //            reset.reset_n
		.csr_write   (csr_write),   //              csr.write
		.csr_read    (csr_read),    //                 .read
		.csr_addr    (csr_addr),    //                 .address
		.csr_wrdata  (csr_wrdata),  //                 .writedata
		.csr_rddata  (csr_rddata),  //                 .readdata
		.avmm_addr   (avmm_addr),   //     vector_slave.address
		.avmm_wrdata (avmm_wrdata), //                 .writedata
		.avmm_rddata (avmm_rddata), //                 .readdata
		.avmm_write  (avmm_write),  //                 .write
		.avmm_read   (avmm_read),   //                 .read
		.irq         (irq)          // interrupt_sender.irq
	);

endmodule
